/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CardiacContractionPhase;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_CardiacContractionPhase;


/**
 * This class represents CardiacCardiacCardiacContractionPhase_CID3472
 */
public class CardiacContractionPhase_CID3472 {
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new CardiacCardiacContractionPhase_CID3472 Template 
	 */
	public CardiacContractionPhase_CID3472()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumCardiacCardiacContractionPhase Object of EnumCM_CardiacCardiacContractionPhase represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_CardiacContractionPhase enumCardiacContractionPhase)
	{
		switch(enumCardiacContractionPhase) 
		{
		case SYSTOLIC: this.strCodeValue =EnumCV_CardiacContractionPhase.SYSTOLIC_F_32020.getValue(); break;
		case DIASTOLIC: this.strCodeValue =EnumCV_CardiacContractionPhase.DIASTOLIC_F_32010.getValue(); break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumCardiacContractionPhase Object of EnumCM_CardiacContractionPhase represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_CardiacContractionPhase enumCardiacContractionPhase)
	{
		switch(enumCardiacContractionPhase)
		{
		case SYSTOLIC : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.SYSTOLIC.getSNOMEDCTID(); break;
		case DIASTOLIC : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.DIASTOLIC.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for CardiacCardiacContractionPhase
	 * @param enumCardiacCardiacContractionPhase Object of EnumCM_CardiacCardiacContractionPhase.
	 */
	public void setCardiacCardiacContractionPhase(EnumCM_CardiacContractionPhase enumCardiacContractionPhase)
	{
		this.strCodeMeaning = enumCardiacContractionPhase.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		setCodeValue(enumCardiacContractionPhase);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumCardiacContractionPhase);
	}
}
